﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace DataLayer.Models
{
    public class BeaconCoordinates
    {
        #region Public Properties

        /// <summary>
        /// Address of beacon
        /// </summary>
        public byte Address { get { return _buffer.Get1Byte(0); } }

        /// <summary>
        /// Coordinate X of beacon in mm
        /// </summary>
        public Int32 X { get { return _buffer.GetInt32(1); } }

        /// <summary>
        /// Coordinate Y of beacon in mm
        /// </summary>
        public Int32 Y { get { return _buffer.GetInt32(5); } }

        /// <summary>
        /// Coordinate Z, height of beacon, in mm
        /// </summary>
        public Int32 Z { get { return _buffer.GetInt32(9); } }

        /// <summary>
        /// Specifies whether location coordinates are valid or not
        /// </summary>
        public bool IsValid { get { return 13 < _buffer.Length  ? ((_buffer[13] & 0x01) == 0x00) : false; } }

        #endregion

        #region Constructors

        public BeaconCoordinates(byte[] buffer)
        {
            _buffer = buffer;
        }

        #endregion

        #region Private Members

        private byte[] _buffer;

        #endregion
    }
}
