﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace DataLayer.Models
{
    public class Packet47_11 : Packet
    {
        public Packet47_11(byte[] buffer) : base(buffer) { }

        /// <summary>
        /// Information about coordinates validity (extracted from the Flags)
        /// </summary>
        public bool IsCoordinatesValid { get { return 21 < _buffer.Length ? ((Flags & 0x01) == 0x00) : false; } }

        /// <summary>
        /// Device address
        /// </summary>
        public byte Address { get { return Get1Byte(22); } }

        /// <summary>
        /// X coordinate in mm
        /// </summary>
        public Int32 X { get { return GetInt32(9); } }

        /// <summary>
        /// Y coordinate in mm
        /// </summary>
        public Int32 Y
        {
            get
            {
                return GetInt32(13);
            }
        }

        /// <summary>
        /// Z coordinate in mm
        /// </summary>
        public Int32 Z
        {
            get
            {
                return GetInt32(17);
            }
        }
        public byte Flags { get { return Get1Byte(21); } }
        public UInt32 Timestamp
        {
            get
            {
                return Get4Bytes(5);
            }
        }
    }
}
